Supplementary Material for "Reinforcement Learning and Data-Generation for Syntax-Guided Synthesis"
to be published at [AAAI 2024](https://aaai.org/aaai-conference/)

Authors: 
Julian Parsert, julian.parsert@gmail.com
Elizabeth Polgreen, elizabeth.polgreen@ed.ac.uk



# CBMC_smt

We recommend using the Docker container (that installs all depencies, git repos etc.) to run the experiments. Etc. 

To modify or change the code etc. one can also install all depencies (as shown in the docker file) by hand.and compile with cmake.

## REQUIREMENTS
* All prerequisties for CBMC must be installed (https://github.com/diffblue/cbmc/blob/develop/COMPILING.md). 
* Z3 must be installed and on the path
* Pyhon3
* Python's tqdm library

## RUN Experiments with DOCKER
We assume the current working directory is the location of this README file.
Note that depending on type of installation the following commands might need to be run using `sudo`

To install the docker container, download dependencies and compile the source code run:

```
docker build -t cbmcsmt .
docker run -it cbmcsmt
```

You should now be in the Docker container in the folder `/home/CBMCSMT/`:

To generate problems from the SMT LIA/QF_LIA we can run the python script:

`python3 src/CBMC_smt/RunCBMCOnDirs.py 1 build/cbmcsmt ../LIA/ newly_generated_LIA_problems`

`python3 src/CBMC_smt/RunCBMCOnDirs.py 1 build/cbmcsmt ../QF_LIA/ newly_generated_QF_LIA_problems`

The resulting SyGuS files will be in `newly_generated_LIA_problems` and `newly_generated_QF_LIA_problems`.
The first integer argument to the scripts denotes the number of process to be run in parallel



## Build with CMAKE
We assume all dependencies are installed. We assume you are in the same directory as this readme.
The following to build:

```
mkdir build
cd build
cmake ../src/CBMC_smt/
make
cd ..
```

There should be a binary called `cbmcsmt` in the build directory.



## Generating problems
To generate the SMT problems we used, we need to first download the LIA/QF_LIA problems

### Get SMT problems:
`git clone https://clc-gitlab.cs.uiowa.edu:2443/SMT-LIB-benchmarks/LIA.git`
`git clone https://clc-gitlab.cs.uiowa.edu:2443/SMT-LIB-benchmarks/QF_LIA.git`


### Run Data Generation
Run generation scripts:
`python3 src/CBMC_smt/RunCBMCOnDirs.py 1 build/cbmcsmt ./LIA/ newly_generated_LIA_problems`
`python3 src/CBMC_smt/RunCBMCOnDirs.py 1 build/cbmcsmt ./QF_LIA/ newly_generated_QF_LIA_problems`

the first argument, `1`, is the number of processes to run in parallel. The second is where the `cbmcsmt` binary, the third one is the location of the smt files and the 4th one is the location to put the new sygus files.


### Modifying

All the useful code is in src/CBMC_smt/smt2_frontend.cpp. Start here.
