; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_14361315896416860311 + -var_9315583888345776691 * var_10974030888938674753 + var_17528294872333901730 + var_670723566458102636 + var_4776955539614171878 + var_12703807162395493407

(set-logic LIA)
(synth-fun synthTarget((var_14361315896416860311 Int)(var_9315583888345776691 Int)(var_10974030888938674753 Int)(var_17528294872333901730 Int)(var_670723566458102636 Int)(var_4776955539614171878 Int)(var_12703807162395493407 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_14361315896416860311 var_9315583888345776691 var_10974030888938674753 var_17528294872333901730 var_670723566458102636 var_4776955539614171878 var_12703807162395493407 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget (* 2 0) 2 0 0 (* (- 1) 0) 0 (* (- 1) 0) ) 1))
(constraint (<= (synthTarget 0 1 0 0 (* (- 1) 0) 0 (* (- 1) 1) ) 1))
(constraint (<= (synthTarget 0 1 1 0 (* (- 1) 0) (* (- 1) 0) 0 ) (- 1)))
(constraint (>= (synthTarget 0 1 0 (* (- 1) 0) 0 (* (- 2) 0) (* 2 0) ) 0))
(constraint (>= (synthTarget 0 1 0 (* (- 2) 0) (* 2 0) 0 (* (- 1) 1) ) (- 1)))
(check-synth)
