; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_6432427973471818984 + -1 * 0 + var_7369772834482527069 + var_12703804030581349382 + var_15438359456792732037 + var_6938054829460592931

(set-logic LIA)
(synth-fun synthTarget((var_6432427973471818984 Int)(var_7369772834482527069 Int)(var_12703804030581349382 Int)(var_15438359456792732037 Int)(var_6938054829460592931 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_6432427973471818984 var_7369772834482527069 var_12703804030581349382 var_15438359456792732037 var_6938054829460592931 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 1 2 (* (- 1) 0) 0 (* (- 1) 3) ) 0))
(constraint (<= (synthTarget 2 0 (* (- 1) 3) (* (- 1) 0) 0 ) (- 1)))
(constraint (<= (synthTarget 3 (* (- 1) 1) 0 0 (* (- 1) 3) ) (- 1)))
(constraint (<= (synthTarget 3 (* (- 1) 2) 0 0 (* (- 1) 3) ) (- 1)))
(constraint (>= (synthTarget 3 (* (- 1) 2) 0 (* (- 1) 1) 0 ) 0))
(check-synth)
