; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_9386894676949743024 + -1 * var_10974152108889204756 + var_15658529626931521672 + -1 * var_10251674583512630079 + var_14718935876491839900 + var_15370776805199702910

(set-logic LIA)
(synth-fun synthTarget((var_9386894676949743024 Int)(var_10974152108889204756 Int)(var_15658529626931521672 Int)(var_10251674583512630079 Int)(var_14718935876491839900 Int)(var_15370776805199702910 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_9386894676949743024 var_10974152108889204756 var_15658529626931521672 var_10251674583512630079 var_14718935876491839900 var_15370776805199702910 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 0 1 0 5 (* (- 1) 2) 0 ) 0))
(constraint (<= (synthTarget 0 5 2 0 2 (* (- 1) 0) ) (- 1)))
(constraint (<= (synthTarget 4 0 0 2 (* (- 1) 11) 0 ) 0))
(check-synth)
