; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_12199868638696568806 + -1 * var_8235510155276668908 + var_17819136096608671226 + var_6146402590773337998 + var_5710888943855374723 + -1 * var_381106950678220247 + var_1678347456076878183 * 0 + var_9025557946333585578

(set-logic LIA)
(synth-fun synthTarget((var_12199868638696568806 Int)(var_8235510155276668908 Int)(var_17819136096608671226 Int)(var_6146402590773337998 Int)(var_5710888943855374723 Int)(var_381106950678220247 Int)(var_1678347456076878183 Int)(var_9025557946333585578 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_12199868638696568806 var_8235510155276668908 var_17819136096608671226 var_6146402590773337998 var_5710888943855374723 var_381106950678220247 var_1678347456076878183 var_9025557946333585578 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 0 3 (* (- 1) 0) 61 0 65 (- 1) 2 ) (- 1)))
(constraint (<= (synthTarget 0 61 123 (* (- 1) 0) 0 65 2 (* (- 2) 0) ) 1))
(constraint (<= (synthTarget 0 8 (* (- 2) 42) (* 2 0) 47 0 (- 2) (* 2 0) ) (- 1)))
(constraint (>= (synthTarget 47 0 (* (- 2) 0) (* 2 3) 0 47 (- 1) 0 ) 0))
(check-synth)
