; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: 0 + -1 * var_17025371527987521161 + var_9604515720903521620 + var_17314526590161461792 + var_10827718083653558076 + var_10038048603713987849 + var_10394405193926035244 + var_8380311104573445491

(set-logic LIA)
(synth-fun synthTarget((var_17025371527987521161 Int)(var_9604515720903521620 Int)(var_17314526590161461792 Int)(var_10827718083653558076 Int)(var_10038048603713987849 Int)(var_10394405193926035244 Int)(var_8380311104573445491 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_17025371527987521161 var_9604515720903521620 var_17314526590161461792 var_10827718083653558076 var_10038048603713987849 var_10394405193926035244 var_8380311104573445491 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 13 (* (- 1) 0) 9 (* (- 1) 0) 0 0 (* (- 1) 0) ) 0))
(constraint (<= (synthTarget 19 (* (- 1) 0) 0 (* (- 1) 1) 1 0 (* (- 1) 0) ) (- 1)))
(constraint (>= (synthTarget 0 (* 2 0) (* (- 2) 13) (* (- 1) 0) 12 (* (- 1) 0) 19 ) 0))
(constraint (>= (synthTarget 0 (* (- 1) 0) 0 (* 2 0) (* (- 2) 0) (* (- 1) 0) 4 ) 0))
(constraint (>= (synthTarget 6 (* (- 1) 0) 0 17 (* (- 1) 0) (* (- 1) 0) 0 ) 0))
(constraint (>= (synthTarget 6 0 (* (- 1) 0) 0 (* (- 1) 0) 11 (* (- 1) 0) ) 1))
(constraint (>= (synthTarget 9 (* (- 1) 0) 0 17 (* (- 1) 0) 0 (* (- 1) 4) ) (- 1)))
(check-synth)
