; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_15081818963157044632 + -1 * var_15439608684353566659 + var_16664719140100161751 + var_10614867347188465220 + var_13929215721693327601 + var_9458999111812190173 + var_2828981012331487770 + var_1896008038349571034

(set-logic LIA)
(synth-fun synthTarget((var_15081818963157044632 Int)(var_15439608684353566659 Int)(var_16664719140100161751 Int)(var_10614867347188465220 Int)(var_13929215721693327601 Int)(var_9458999111812190173 Int)(var_2828981012331487770 Int)(var_1896008038349571034 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_15081818963157044632 var_15439608684353566659 var_16664719140100161751 var_10614867347188465220 var_13929215721693327601 var_9458999111812190173 var_2828981012331487770 var_1896008038349571034 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 0 0 1 (* (- 1) 0) (* (- 1) 0) 0 (* (- 1) 2) 0 ) (- 1)))
(constraint (<= (synthTarget 1 0 (* (- 1) 0) 2 (* (- 1) 3) 0 (* (- 1) 0) 0 ) 0))
(constraint (>= (synthTarget 0 0 (* (- 1) 0) 2 0 (* (- 1) 0) 0 (* (- 1) 0) ) 1))
(constraint (>= (synthTarget 0 1 3 (* (- 1) 0) (* (- 2) 0) (* 2 0) 0 (* (- 1) 0) ) 1))
(check-synth)
