; smt-lib-version 2.6
; source 
;Generated by: Martin Bromberger
;Generated on: 2018-01-06
;Application: This is a problem with unbounded directions and, therefore, a good test for the termination/completeness of branch-and-bound solvers.
;Publications: M. Bromberger. A Reduction from Unbounded Linear Mixed Arithmetic Problems into Bounded Problems. (Work in progress.)
;
;The benchmarks in this class are based on the problems from SMT-LIB/QF_LIA/CAV_2009 and SMT-LIB/QF_LIA/cut_lemmas.
;I just replaced all variables x with x_+ - x_-, where x_+ and x_- are two new variables such that x_+, x_- >= 0.
;This transformation is equisatisfiable.
;The new variables and an unsatisfiable status guarantee that there are bounded and unbounded directions.
;Target solver: CVC4 Mathsat SPASS-IQ YICES Z3
;
; license https://creativecommons.org/licenses/by/4.0/
; category crafted
; status sat
; Solution: var_17316065290209322458 + -1 * var_11118295626136379299 + var_1822013725114363921 + var_10323998140405688271 + var_17384893453428540610 + var_11692091190670200365 + var_15657582578819649986 + -1 * 0

(set-logic LIA)
(synth-fun synthTarget((var_17316065290209322458 Int)(var_11118295626136379299 Int)(var_1822013725114363921 Int)(var_10323998140405688271 Int)(var_17384893453428540610 Int)(var_11692091190670200365 Int)(var_15657582578819649986 Int)) Int
((NTInt Int)(NTbool Bool))
((NTInt Int (var_17316065290209322458 var_11118295626136379299 var_1822013725114363921 var_10323998140405688271 var_17384893453428540610 var_11692091190670200365 var_15657582578819649986 0 1 (- NTInt) (+ NTInt NTInt) (- NTInt NTInt) (ite NTbool NTInt NTInt) ))
(NTbool Bool ((not NTbool) (and NTbool NTbool) (or NTbool NTbool) (ite NTbool NTbool NTbool) (= NTInt NTInt) (< NTInt NTInt) (> NTInt NTInt) ))
)
)

(constraint (<= (synthTarget 0 2 0 (* (- 1) 0) 0 (* (- 1) 2) 0 ) (- 1)))
(constraint (>= (synthTarget 0 0 (* (- 1) 0) 0 (* (- 1) 0) 0 1 ) 0))
(constraint (>= (synthTarget 1 0 0 (* (- 1) 0) (* (- 1) 0) 0 0 ) 1))
(check-synth)
